import urllib
from BeautifulSoup import BeautifulSoup
import re
import cPickle

def scrape_times(url,timelist):
    f = urllib.urlopen(url)
    s = f.read()
    print " read: ", len(s), " bytes from ", url
    f.close()
    soup = BeautifulSoup(s) 
    table = soup.find("table") 

    n = 1
    rows = table.findAll('tr')
    print " looping through ", len(rows), " rows"
    
    for row in rows:
        #print row
        col = row.findAll('td')
        #print n, " : cols: ", len(col)
        #break
        rank=col[0].string # first column should have rank of runner

        if rank is None:
            r = n
        elif rank.isdigit():
            r = int(rank)
        
        tmp = col[1].string 
        name = col[2].string 
        t = col[3].string # timr

        
        timepat = re.compile(r'^(\d{1}).(\d{2}).(\d{2})')
        timepat2 = re.compile(r'^(\d{2}).(\d{2})')
        t2s=[0,0,0]
        try:
            t2s = timepat.search(t).groups() # this works for: hour:minute:second
        except AttributeError:
            tmp = timepat2.search(t).groups() # this works for: minute:secod. in this case hours=0
            t2s[0]=0
            t2s[1]=tmp[0]
            t2s[2]=tmp[1]
            
        # convert to minutes
        mins = float(t2s[0])*60 + float(t2s[1]) + float(t2s[2])/float(60)
        print n,": h=",t2s[0], " m=",t2s[1]," s=",t2s[2]," mins=",mins

        timelist.append(mins) # append only the minutes to the list which is saved.
        n = n+1

    return n-1

def printtime(mins):
    h = float(mins)/float(60)
    hint = int(h)
    m = (h-hint)*60
    mint = int(m)
    s = (m-mint)*60
    sint = s
    print hint,":",mint,":",sint 
    
if __name__ == "__main__":  
    url_list = []
      
    #url = "2.htm" 
    #filename = "jukola2013_2.pickle"
    
    url = "1.html" 
    filename = "jukola2013_1.pickle"
    
    url = "3.html" 
    filename = "jukola2013_3.pickle"
    
    url = "4.html" 
    filename = "jukola2013_4.pickle"
    
    url = "5.html" 
    filename = "jukola2013_5.pickle"
    
    url = "6.html" 
    filename = "jukola2013_6.pickle"

    url = "7.html" 
    filename = "jukola2013_7.pickle"

    timelist=[]
    scrape_times(url,timelist)

    print " got ",len(timelist)," times"

    print " writing file: ",  filename
    cPickle.dump(timelist, open( filename , 'wb')) 
